# bulletin Au fil des maths de l'APMEP
# Problème nº 534-1 page 66, de Jean-Christophe Berthonnaud

# Le nombre de Champernowne est un nombre obtenu en concaténant après la virgule
# la suite des entiers naturels:
#
# 0,123456789101112131415161718192021...

# Auteur de la solution: Olivier Pontini

from math import *

def nb_chiffres (n):
    '''
    Renvoie le nombre de chiffres de l'entier n.
    n doit être un strictement positif
    '''
    return (floor(log(n,10)) + 1)
    
def decaler (n, r):
    # on décale l'entier n de r rangs
    n = floor( n / ( 10 ** r ) )
    # puis on renvoit le chiffre des unités
    return n % 10
    
def nieme_chiffre(N):
    '''
    Renvoie la N-ième décimale du nombre de Champernowne
    '''
    k = 0 # nombre entier que l'on concatène
    rang = 0 # rang du chiffre des unités du dernier entier concaténé 
    while rang < N:
        k = k + 1
        rang = rang + nb_chiffres(k)
    # Si on a dépassé N, il faut revenir en arrière:
    return decaler(k, rang-N)



